﻿#NoEnv
#SingleInstance Force
SetTitleMatchMode, 2
SetWorkingDir %A_ScriptDir%
SetBatchLines -1
; This is the WayText application code.
; updated 6-3-2022

Menu, Tray, Icon, shell32.dll, 81   ; I think this is the old "disc defrag" icon?

;==========Read from Settings file======== 
iniread, varHotkey, wtFiles\Settings.ini, MainSettings, MyHotkey
iniread, varStayInRAM, wtFiles\Settings.ini, MainSettings, StayInRAM
iniread, varVisualMode, wtFiles\Settings.ini, MainSettings, VisualSendMode
iniread, varPasteDelay, wtFiles\Settings.ini, MainSettings, PostPasteDelay
iniread, varTypeDelay, wtFiles\Settings.ini, MainSettings, PostTypeDelay
iniread, varFaveEditor, wtFiles\Settings.ini, MainSettings, FaveEditor
iniread, varTargetWins, wtFiles\Settings.ini, MainSettings, PreferredTargetWins
iniread, varForcePref, wtFiles\Settings.ini, MainSettings, ForceUseOfPreferred
iniread, varTodayAt, wtFiles\Settings.ini, schedule, %A_DDDD%
iniread, varRememberStu, wtFiles\Settings.ini, MainSettings, RememberStudent
iniread, varFontColor, wtFiles\Settings.ini, MainSettings, FontColor
iniread, varDebug, wtFiles\Settings.ini, MainSettings, Debug
;=========================================

If (varStayInRAM != 1)  ; If varStayInRAM =/= 1, then skip the hotkey and just run the tool. 
	goto, DontWait
Hotkey, %varHotkey%, DontWait

DontWait: 
WinGetActiveTitle, myWinTarget ; Get name of active Window so we can wait for it later.
WinGetPos, X, Y, W, H, A   ; "A" to get the active window's pos.
X := X + (W * 0.05) ; Use these with GUI Show, below.
Y := Y + (H * 0.2)
If (myWinTarget = "") ; && (varStayInRAM = 1)
	Exit ; Otherwise WayText launches at Windows startup and errors because no active window. 

ControlGetFocus, fieldFocus, A
If InStr(fieldFocus, "edi") || If RegExMatch(myWinTarget, varTargetWins) ; Colorizes GUI with "warning" color.
{
	Preferred := ""
	iniread, varColor, wtFiles\Settings.ini, MainSettings, GUIcolor 
	; This is the normal color of the form.
	if (strLen(varColor) > 8)
		varColorCode := subStr(varColor, strLen(varColor) - 5, 6)
	else
		varColorCode = %varColor%
}
else
{
	Preferred := "non"
	iniread, varColor, wtFiles\Settings.ini, MainSettings, GUIwarnColor 
	; This is the Warning Color, indicating non-preferred Window.
	if (strLen(varColor) > 8)
		varColorCode := subStr(varColor, strLen(varColor) - 5, 6)
	else
		varColorCode = %varColor%
}

if (strLen(varFontColor) > 8)
	varFontColorCode := subStr(varFontColor, strLen(varFontColor) - 5, 6)
else
	varFontColorCode = %varFontColor%
	

varLastStuName := "Student" ; Remember Student = 0, so use these defaults. 
ckMale := "1"
ckFemale := "0"
ckNeutral := "0"

If (varRememberStu = 1) ; If Remember Student = 1, then overwrite the 4 above values. 
{
	iniread, varTimeStamp, wtFiles\Settings.ini, MainSettings, MemoryTimeStamp
	TimeDiff :=  A_Now - varTimeStamp ; returns number of seconds passed
	iniread, varMemoryMinutes, wtFiles\Settings.ini, MainSettings, MemoryMinutes
	varMemoryMinutes := varMemoryMinutes * 60
	If (TimeDiff < varMemoryMinutes)
	{
		iniread, varLastStuName, wtFiles\Settings.ini, MainSettings, LastStuName 
		; "Last-used" student name, not "last name" of student.
		iniread, varLastStuSchool, wtFiles\Settings.ini, MainSettings, LastStuSchool ; Returns a name.
		IniRead, AllSchools, wtFiles\SchoolList.ini ; Gets `n-delimited list from ini file.
		loop, parse, AllSchools, `n, `r
		{
			If (A_LoopField = varLastStuSchool) 
				 varTodayAt = %A_Index% ; Convert school name to digit.
				
		}
	
		iniread, varLastStuGender, wtFiles\Settings.ini, MainSettings, LastStuGender
		If (varLastStuGender = "2")
		{
			ckFemale := "1"
			ckMale := "0"
		}
		If (varLastStuGender = "3")
		{
			ckNeutral := "1"
			ckMale := "0"
		}
	}		
}	

Gui, Destroy
Gui, font, c%varFontColorCode%
gui, color, %varColorCode%
Gui, -MinimizeBox +alwaysOnTop
Gui, Font, s11 
Gui, Add, Edit, x14 y8 w220 h25 vStudentName cBlack, %varLastStuName%  ; Box to type in name.
Gui, Add, Radio, xs y40 w60 h20 vGender checked%ckMale%, &Male ; Radio group for gender.
Gui, Add, Radio, xp+60 y40 w80 h20 checked%ckFemale%, &Female 
Gui, Add, Radio, xp+78 y40 w80 h20 checked%ckNeutral%, &Neutral
Gui Add, Text, x240 y6 w138 h125 +wrap, --- Target Window ---`n %myWinTarget% 
; Identify which window will get typed into. 
Gui Add, Tab3, x12 y64 0x400 vCurrTab, Notices|Tests ; The tabs.  

Gui Tab, 1 ;###### Notices ##########################################################

IniRead, AllSchools, wtFiles\SchoolList.ini ; Gets `n-delimited list from ini file.
If (!AllSchools) ; If file not found, use below error statement.
	AllSchools := "'SchoolList' file not found."
AllSchools := StrReplace(AllSchools,"`n","|",SchRows) ; Must|convert|to|this.
SchRows++  ; The number of strReplacements +1.  The ListBox will be this high.
Gui, Add, ListBox, r%SchRows% w330 vSchChoice cBlack Choose%varTodayAt%, %AllSchools%

AllNotices := ""
IniRead, AllNotices, wtFiles\NoticeDefinitions.ini 
If (!AllNotices)
	AllNotices := "'NoticeDefinitions' file not found."
AllNotices := StrReplace(AllNotices,"`n","|",NoteRows) 
NoteRows++
;Gui, Add, ListBox, r%NoteRows% w330 sort vNoteChoice gDblClick, %AllNotices%
Gui, Add, ListBox, r%NoteRows% w330 vNoteChoice gDblClick cBlack Choose1, %AllNotices% ; Removed sort

Gui, Add, Button, w70 h30 Section, Insert
Gui, Add, Button, ys x+5 w70 h30, Schools
Gui, Add, Button, ys x+5 w70 h30, Notices
Gui, Add, Button, ys x+5 w30 h30, Ψ
Gui, Add, Button, ys x+5 w70 h30, Esc

Gui Tab, 2 ;###### Tests ############################################################

IniRead, MySuffixes, wtFiles\TestSuffixes.ini
If (!MySuffixes)
	MySuffixes := "'TestSuffixes' file not found."
MySuffixes := StrReplace(MySuffixes,"`n","|")  		
Gui, Add, ComboBox, w240 vSuffChoice cBlack Choose1, %MySuffixes%

IniRead, MySuffixes, wtFiles\TestSuffixes.ini 
; Deactivated with below checkbox and TogSub subroutine. 
MySuffixes := StrReplace(MySuffixes,"`n","|")  		
Gui, Add, ComboBox, w240 vSuffsubChoice cBlack Disabled, %MySuffixes%

AllTests := ""
IniRead, AllTests, wtFiles\TestBank.ini
If (!AllTests)
	AllTests := "'TestBank' file not found."
AllTests := StrReplace(AllTests,"`n","|",TestRows) 
TestRows++
Gui, Add, ListBox, r%TestRows% w330 sort vTestChoice gDblClick cBlack Choose1, %AllTests%

Gui, Add, Button, w70 h30 Section, Insert
Gui, Add, Button, ys x+5 w70 h30, Suffix
Gui, Add, Button, ys x+5 w70 h30, Tests
Gui, Add, Button, ys x+5 w30 h30, S ;Ψ
Gui, Add, Button, ys x+5 w70 h30, Esc

Gui, Font, s9
Gui Add, CheckBox, x275 y113 h22 vTogVar gTogSub Checked, link them ; Activates below GoSub "TogSub." 
Gui Add, Text, x275 y95  h22 +0x200, Composites
Gui Add, Text, x275 y130  h19 +0x200, Sub Scales

Gui, Font, s11

Gui Tab ;############################################################################

Gui Show, x%X% y%Y%, WayText  ; Position form based on coordinates obtained above. 
Return

TogSub: ; In Tests Tab, disables/enables subTest comboBox.
Gui, Submit, NoHide
If (TogVar = 0)
	GuiControl, Enable, SuffsubChoice
Else If (TogVar = 1)
	GuiControl, Disable, SuffsubChoice	
Return

ButtonEsc:
GuiEscape:
GuiClose:
If (varStayInRAM != 1)
 ExitApp
else
{
	Gui, Hide
	Exit
}

DblClick:
	IfNotEqual A_GuiControlEvent,DoubleClick ; Ignore double-clicks unless it was on a list item. 
Return
	Else
ButtonInsert:
Gui, Submit

If (varRememberStu = 1) ; Should we remember the student information?
{
	iniWrite, %A_Now%, wtFiles\Settings.ini, MainSettings, MemoryTimeStamp
	iniWrite, %StudentName%, wtFiles\Settings.ini, MainSettings, LastStuName
	iniWrite, %Gender%, wtFiles\Settings.ini, MainSettings, LastStuGender
	iniWrite, %SchChoice%, wtFiles\Settings.ini, MainSettings, LastStuSchool 
}

MyEntry := ""
IfEqual, CurrTab, Notices ; Checks which tab is being used.
	IniRead, MyEntry, wtFiles\NoticeDefinitions.ini, %NoteChoice%  ; From notice type, goes back to INI, gets notice content.

IfEqual, CurrTab, Tests
	IniRead, MyEntry, wtFiles\TestBank.ini, %TestChoice%, ; Gets content about test. Puts in MyEntry.
			;------------------------------------------------------
			If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
				 msgbox,, First check, Entry has been obtained we will 
				 ,now check for INI Key Names with Options:`n`n |%MyEntry%|
			;------------------------------------------------------

; "s)\R(\V*\bpaste\b\V*=)(.+?)(\V+=\V*($)|$)"  If key has "paste" in it, and key val has no new lines. 
;OOOOOOOOOOOOOOOOOOOOOOOOOO check for sub GUI options OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

if !RegExMatch(MyEntry, "s)\R\V*\bOptional\b\V*=\R")	; Check for any keys with "Optional" in key name. 
	goSub, ContinueScript								; If not, skip this whole section.
else
{		; The matching } is 100 lines down. 
	IfEqual, CurrTab, Notices
		entrylbl = %NoteChoice%  ; Merely used in the Gui label
	IfEqual, CurrTab, Tests
		entrylbl = %TestChoice%

	TopOfLoop: ; Script comes back here until there are no more key names with "optional". 
			;------------------------------------------------------   
			If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
				 msgbox,, Check at top of 'option' loop, At least one Option key has 
				 ,been found.`n`nLoop number: %A_Index% `n`n |%MyEntry%|
			;------------------------------------------------------
  
 ;MsgBox  Before TD RE `ntheKey = %outVar1% `n`ntheList = %outVar2%
  
  
  
   RegExMatch(MyEntry, "s)\R(\V*\bOptional\b\V*=)\R(.+?)\R*(\V+=\V*(\R|$)|$)", outVar)  ; Teadrinker's regex.
	theKey = %outVar1%
	theList = %outVar2%
	
	
; MsgBox  After TD RE `ntheKey = %outVar1% `n`ntheList = %outVar2%	
	
	vPun = 0 ; By default, assume there is no punctuation needed. 

	If InStr(theKey, "Radio") ; Determine if Radio Buttons are desired.
		{
			vRad = 1
			guiType := "Radio"
		}
		else
		{
			vRad = 0
			guiType := "Checkbox"
		}
	If InStr(theKey, "Punctuat") ; Determine if the items should get "x, y, and z"; or "just x y z".
		vPun = 1
		
	myOptions= ; Use this varible to hold the optional items that were checked.
	IfEqual, vPun, 1
		mylbl := " or more (punctuated) items." ; Merely used in the Gui label
	else IfEqual, vRad, 1
		mylbl := " option item."
	else
		mylbl := " or more items."

	Gui, +Owner
	Gui, o:Destroy ; Ensures that only one instance of the miniform occurs at a time. 
	Gui, o:-MinimizeBox +alwaysOnTop
	Gui, o:font, c%varFontColorCode% s11
	gui, o:color, %varColorCode%
	Gui, o:Add, Text, ,For [%entrylbl%]`nSelect one%mylbl%
	Loop, Parse, theList, `n,`r  ; Parses list.
		{
			fchar := SubStr(A_LoopField, 1, 1)
			If fchar is Number ; Get first char and see if it's a digit.
				item := SubStr(A_LoopField, 3, 99) ; If so, chop first 2 chars. 
			else
				item := A_LoopField ; If not a digit, use entire line. 
				;------------------------------------------------------
							If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
								MsgBox,, Checking Optional Item, In preparation for displaying the mini gui.
								,The first character is: |%fchar%|`n`nFor item: |%item%|
				;------------------------------------------------------
			Gui, o:Add, %guiType%, Checked%fchar% vCheckbox%a_index%, %item% ;Dynamically make one per item.
		}
	Gui, o:Add, Button, default xm w50 gMyOpts, Use
    If (guiType = "Checkbox") { ; Only add these buttons if it's checkboxes.
        Gui, o:Add, Button, yp x+5 w50 gAll, All
        Gui, o:Add, Button, yp x+5 w50 gNone, None
    }
	Gui, o:Add, Button, yp x+5 w50 gCancelOpts, Cancel
	Gui, o:Show,x%X% y%Y% , Option Items ; Show miniform at same location as main MutliTool form.
	Return
    
    All: ; From Select "All" button of mini form.
    Gui, o:Submit, NoHide
    WinGet, list, ControlList
	For each, control in StrSplit(list, "`n")
		 GuiControl,,Checkbox%A_Index%,1
    return
    None: ; From Select "None" button of mini form.
    Gui, o:Submit, NoHide
    WinGet, list, ControlList
	For each, control in StrSplit(list, "`n")
		 GuiControl,,Checkbox%A_Index%,0
    return
    
	MyOpts: ; Go here when user clicks "Use" button.
	Gui, o:Submit
	vCount= ; Need this var for puntuation.
	Loop, parse, theList, `n
		{
			fchar := SubStr(A_LoopField, 1, 1)
			If Checkbox%a_index% <> 0 ; The unchecked ones will be zero.
			{
				vCount = %a_index%
				If fchar is Number ; Again, if 1st char is digit, chop 1st two. 
					item := SubStr(A_LoopField , 3, 9999)
				else
					item := A_LoopField ; Otherwise, use whole line.
				IfEqual, CurrTab, Notices
				{
					IfEqual, vPun, 1 ; If Puncuation flag found, separate with comma
						myOptions = %myOptions%, %item%
					else
						myOptions = %myOptions% %item%
				}
				else
					myOptions = %myOptions%`n%item%  ; If currTab is Tests, keep list as a list.
			}
			;------------------------------------------------------
					If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
						MsgBox,, Bottom of opts loop, Loop number %A_Index% `nOne loop per item to append the 
						,selected ones.`nvariable is:`n|%myOptions%|
			;------------------------------------------------------
		}
	IfEqual, vPun, 1
	{ ; If punctuation was used, chop first comma, then insert "and" before last item. 
		myOptions := SubStr(myOptions, 3, 999999)
		IfEqual, vCount, 2 ; If there were exactly 2 items checkmarked, just use "and."
			myOptions := StrReplace(myOptions,", " . item," and " . item)
		myOptions := StrReplace(myOptions,", " . item,", and " . item) ; Otherwise, Oxford comma. 
	}
		
	MyEntry := StrReplace(MyEntry, theList, " " . myOptions,, 1) 
	
	;MsgBox above strRep myEntry is |%myEntry%|`n`n`ntheList is |%theList%|`n`n`ntheKey is |%theKey%|`n`n`nmyOptions is |%myOptions%|
	MyEntry := RegExReplace(MyEntry, "i)Optional(?=[^\n\r]*=)", "OptX",,1) 
	;MsgBox below strRep myEntry is |%myEntry%|`n`n`ntheList is |%theList%|`n`n`ntheKey is |%theKey%|`n`n`nmyOptions is |%myOptions%|
	
	If RegExMatch(MyEntry, "s)\R\V*\bOptional\b\V*=\R", "")  ; Options key found in expansion text.
		Gosub, TopOfLoop ; If found, run this section again.
	Else
	{
		MyEntry := StrReplace(MyEntry, "=`n", "=") ; EXPERIMENTAL - Trying to turn opt key into regular key.
		Gosub, ContinueScript ; If they've all been replaced, continue below.
	}
	Return	

	CancelOpts:  ; If users presses "Cancel" then ...
	If (varStayInRAM != 1)
	 ExitApp ; If 'Stay in RAM' set to 0, total exit.
	else
	{
		Gui, o:Hide  ; If 'Stay in RAM' set to 1, close form, but stay in memory.
		Exit
	}
} ; This brace closes the "else" 100 lines up. 
;OOOOOOOOOOOOOOOOOOOO end of options OOOOOOOOOOOOOOOOOOOO

ContinueScript:
				;------------------------------------------------------
				If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
					 msgbox,, Past Optional loop, All Optional keys have been resolved.  Next is [r]eplacments.`n`n %MyEntry%
				;------------------------------------------------------
IniRead, MyContactInfo, wtFiles\SchoolList.ini, %SchChoice%, ContactInfo ; From school choice, gets contact info.
IniRead, MySchPhone, wtFiles\SchoolList.ini, %SchChoice%, SchPhone
MyEntry := StrReplace(MyEntry,"[c]",MyContactInfo) 
MyEntry := StrReplace(MyEntry,"[p]",MySchPhone)

IfEqual, CurrTab, Tests
{
	ifNotEqual, SuffChoice, ; Only gets Suffix Description if comboBox is not empty.
		IniRead, MySuffDesc, wtFiles\TestSuffixes.ini, %SuffChoice%
	MyEntry := StrReplace(MyEntry,"[sd]",MySuffDesc)
	MyEntry := StrReplace(MyEntry,"[co]",SuffChoice A_Space) ; "co" for "composite score"
;	MyEntry := RegExReplace(MyEntry,"(\n)+[ a-zA-Z0-9]+=")  ; Removes all Key names from notice definitions.
	If (TogVar = 0)
		MyEntry := StrReplace(MyEntry,"[su]",SuffsubChoice A_Space) ; "su" for "sub scale"
	Else If (TogVar = 1)
		MyEntry := StrReplace(MyEntry,"[su]",SuffChoice A_Space)
		
	if RegExMatch(MyEntry, "is).*Paste.*=") ; Error catcher in case user put paste command in key of test ini.
		MsgBox 0x30, Cannot Paste, WayText has detected a 'Paste' command in one or more key names of this entry.  Unlike Notices`
		, Tests must be typed in order to preserve the list structure.  `n`nPlease remove 'Paste' from the key name(s) for ini section`n[%TestChoice%].`n`n Press OK to continue typing it. 
}	

IfEqual, Gender, 1 ; Checks the results of the gender radio buttons group and assigns variables.
{
   varHeShe = he
   varHimHer = him
   varHisHer = his
   varHisHers = his
}
IfEqual, Gender, 2
{
   varHeShe = she
   varHimHer = her
   varHisHer = her
   varHisHers = hers
}
IfEqual, Gender, 3
{
   varHeShe = they
   varHimHer = them
   varHisHer = their
   varHisHers = theirs
}

MyEntry := StrReplace(MyEntry,"[n]",StudentName) ; Makes the replacements.

MyEntry := StrReplace(MyEntry,"[e]",varHeShe) ; Gender pronouns.
MyEntry := StrReplace(MyEntry,"[m]",varHimHer)
MyEntry := StrReplace(MyEntry,"[s]",varHisHer)
MyEntry := StrReplace(MyEntry,"[r]",varHisHers)

			;------------------------------------------------------
			If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
				 msgbox,, Below pronouns, Name and Pronoun replacements have been made. [n] [e] [m] [s] [r]`n`n %MyEntry%
			;------------------------------------------------------

if instr(MyEntry, "{clipboard}") ; Look for clipboard flag and insert clipboard contents if present.
{
	myClipContent = %clipboard%
	myEntry := StrReplace(MyEntry, "{clipboard}", myClipContent)
}

if instr(MyEntry, "{now,")  ; Look for datestamp tag and insert if needed.  
{
RegExMatch(MyEntry, "{now, ?(.+?)}", DateFormat)
FormatTime, MyDate, %A_Now%, %DateFormat1%
MyEntry := strReplace(MyEntry, DateFormat, MyDate)
}

IfEqual, Gender, 3 ; This part gets skipped if gender = male or female.
{
					;------------------------------------------------------
						If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
						 msgbox Gender is Neutral so several gramar fixes will be attempted.
					;------------------------------------------------------
	If InStr(MyEntry, "they ")
	{
					;------------------------------------------------------
						If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
							msgbox,, Grammar checking, 'They' found.`nBefore fixing 'they is/are/has/was/'s':`n%MyEntry%
					;------------------------------------------------------
		MyEntry := StrReplace(MyEntry,"they is","they are") ; Fix gramar if gender neutral.
		MyEntry := StrReplace(MyEntry,"they's","they are") ; Can break with "he's done that."
		MyEntry := StrReplace(MyEntry,"they has","they have")
		MyEntry := StrReplace(MyEntry,"they was","they were")
					;------------------------------------------------------
						If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
								msgbox,, Grammar checking, 'They' found.`AFTER fix:`n%MyEntry%
					;------------------------------------------------------
		;-----EXPERIMENTAL! will the loop below cause grammar mistakes? It is intended to look for 
		;plural words that follow "they" and make them singular.  For example "They needs help" 
		;is changed to "They need help."  
		loop, parse, myEntry, "." 
		{
					;------------------------------------------------------
					If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
							preSeg= %A_LoopField%
					;------------------------------------------------------
			if (regexmatch(A_LoopField, "s)((T|t)hey\s\w*)ies\b"))
				segment := RegExReplace(A_LoopField, "s)((T|t)hey\s\w*)ies\b", "$1y") 
			Else if (regexmatch(A_LoopField, "s)((T|t)hey\s\w*ly\s\w*(s|z|sh|ch|x|o))es\b"))
				segment := RegExReplace(A_LoopField, "s)((T|t)hey\s\w*ly\s\w*(s|z|sh|ch|x|o))es\b", "$1") 
			Else if (regexmatch(A_LoopField, "s)((T|t)hey\s\w*(s|z|sh|ch|x|o))es\b"))
				segment := RegExReplace(A_LoopField, "s)((T|t)hey\s\w*(s|z|sh|ch|x|o))es\b", "$1")
			Else if (regexmatch(A_LoopField, "s)((T|t)hey\s\w*ly\s\w*)s\b"))
				segment := RegExReplace(A_LoopField, "s)((T|t)hey\s\w*ly\s\w*)s\b", "$1") 
			Else if (regexmatch(A_LoopField, "s)((T|t)hey\s\w*)s\b"))
				segment := RegExReplace(A_LoopField, "s)((T|t)hey\s\w*)s\b", "$1") 
			else 
				segment = %A_LoopField%
			combined = %combined% %segment%.
					;------------------------------------------------------
						If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
							msgbox,, Grammar checking, Sentence %A_Index% starts as; and ends as:`n%preSeg%`n%segment%
					;------------------------------------------------------
			MyEntry := RegExReplace(combined, "D)\Q. .\E$", ".") 
			; Gets rid of that extra dot that's caused by the last parse loop. 
		}
	}
} ; End of gender gramar fixes.

MyEntry := RegExReplace(MyEntry, "^\w|(?:\.|:)(\s|\R|\Q{Enter}\E)+\K\w", "$U0") ; Makes sure most sentences are capitalized.

MyEntry := StrReplace(MyEntry, "`n`n", "`n") ; Get rid of duplicate new lines. Is this even needed?
gui, Hide  ; GUI is already hidden at this point..??
	; If shift key is held down, OR nonpreferred+setting use MsgBox.
	
			;------------------------------------------------------
			If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
				 msgbox After getting rid of extra lines.`n`n %MyEntry%
			;------------------------------------------------------

If (GetKeyState("Shift", "P")) || If (Preferred = "non" AND varForcePref = 1) 
{
	MyEntry =`n%MyEntry% ; Adds an new-line at beginning so below regex will work.
	MyEntry := RegExReplace(MyEntry,"(\n)+[ a-zA-Z0-9]+=")  ; Removes all Key names from notice definitions.
	IfNotEqual, CurrTab, Tests
        StringReplace, MyEntry, MyEntry,`n, , All ; Gets rid of any leftover newline chars.	
   MsgBox,, Text Sent by WayText, %MyEntry%
}
else ; Normal state:  We'll paste or type.
{
    ifEqual, varVisualMode, 1
        SendMode Event 	;Send is the same as SendEvent. It is more visual but prone to errors.
    else,
        SendMode Input	;SendInput is faster but you often can't see progress of typing.  
		  
	if RegExMatch(MyEntry, "is).*Paste.*=") and (CurrTab = "Notices") ; There is a paste command, so use the array (but not for tests).
   {
			clpOld := clipboardAll ; Save the previous Clipboard contents and restore them at the end. 
			
         PasteMode := 0  ; Always type out text by default.    
         myArray := []
         MyEntry := StrReplace(MyEntry, "`n`n", "`n")
         loop, parse, MyEntry, `n ; Break up variable line by line.
         {
						;------------------------------------------------------
							If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
								 MsgBox,, Type or Paste, Breaking up entry line by line.`nThe key name and value 
								 ,for Loop %A_Index% is:`n`n%A_Loopfield%
						;------------------------------------------------------
            data := StrSplit(A_LoopField, "=") ; Split each line at the '=' sign. 
            myArray.Push({key:data[1],value:data[2]}) ; Add to end of myArray.
         }
       
         for each, item in myArray
         {
						;------------------------------------------------------
							If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
								 MsgBox % "Separating key name: `n" item.key "`n`nFrom key value: `n" item.value
						;------------------------------------------------------
            If InStr(item.key, "Paste") ; If the key name has 'paste' set it to PasteMode.
                PasteMode := 1
            Else If InStr(item.key, "Type") ; If the key has 'Type' remove PasteMode.
               PasteMode := 0
               
            If (item.value = "") ; If there is a blank line with no key, this will catch it. 
                item.value := A_Space item.key
					 
				If (PasteMode = 0)
                {
						item.value := StrReplace(item.value,"!","{!}") ; These special characters need {braces} to type correctly.
						item.value := StrReplace(item.value,"#","{#}") ; They should only get braces for typing though.  
						item.value := StrReplace(item.value,"+","{+}")
						item.value := StrReplace(item.value,"^","{^}")
					}
					
            item.value := StrReplace(item.value, "  ", " ")
            item.value := StrReplace(item.value, ". ", ".  ")
            winwaitactive, %myWinTarget% ; Wait for the previously active Window. 
            If (PasteMode = 1)
            {
					Clipboard = ; Gets restored at the end.
							;------------------------------------------------------
								  If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
								  {
										tempvar = % item.value
										MsgBox For Loop %A_Index%, Paste mode is Yes.  
										,Clipboard starts as`n|%Clipboard%|`n`nitem value is`n|%tempvar%|
									}
							;------------------------------------------------------
                Clipboard = % item.value
		; MsgBox is clp item value?`n`n%Clipboard%`n`ndelay is %varPasteDelay%
                 send ^v
					  Sleep %varPasteDelay%
					 
            }
            ; Else if (PasteMode = 0)        
            Else
				{
								;------------------------------------------------------
									If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
									{
										tempvar = % item.value
										MsgBox For Loop %A_Index%, Paste mode is No.`n`nitem to be typed is`n|%tempvar%|
									}
								;------------------------------------------------------
					send % item.value
					IfEqual, varTypeDelay, 1
					{
						len := StrLen(item.value)  ; Added dynamic sleep on 5-16-2022 so the paste won't happen until typing is complete. 
						len := 200 + (len * 2)
						;MsgBox varTypeDelay is |%varTypeDelay%|`n`nlen is |%len%|
						Sleep, %len%
					}
				}
        }
		Clipboard := clpOld ; Restore previous Clipboard contents. 
		ClipWait, 1  
    }
    Else
    {
        MyEntry =`n%MyEntry% ; Adds an new-line at beginning so below regex will work.
        MyEntry := RegExReplace(MyEntry,"(\n)+[ a-zA-Z0-9]+=")  ; Removes all Key names from notice definitions.
        IfNotEqual, CurrTab, Tests
           StringReplace, MyEntry, MyEntry,`n, , All ; Gets rid of any leftover newline chars, but not for tests.	
		  winwaitactive, %myWinTarget% ; Wait for the previously active Window. 
        Send %MyEntry%
    }
}

				;------------------------------------------------------
				If (varDebug = 1) ; DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG  DEBUG 
					 msgbox Text sent and done.
				;------------------------------------------------------
    
If (varStayInRAM != 1)
 ExitApp 	; If 'Stay in RAM' set to 0, total exit.
Exit		; If 'Stay in RAM' set to 1, close form, but stay in memory.

;=========  Other Buttons go to here if clicked ===============
ButtonSchools:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\SchoolList.ini",, UseErrorLevel 
		If ErrorLevel 
			run, wtFiles\SchoolList.ini ; If Scite is not found, will be prompted to choose default ini opener.
return

ButtonNotices:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\NoticeDefinitions.ini",, UseErrorLevel
		If ErrorLevel 
			Run, wtFiles\NoticeDefinitions.ini
return

ButtonSuffix:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\TestSuffixes.ini",, UseErrorLevel
		If ErrorLevel 
			run, wtFiles\TestSuffixes.ini
return

ButtonTests:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\TestBank.ini",, UseErrorLevel
		If ErrorLevel 
			run, wtFiles\TestBank.ini
return

ButtonΨ:
	run, wtSettings.exe
return
