#SingleInstance Force
#NoEnv
SetWorkingDir %A_ScriptDir%
SetBatchLines -1
Menu, Tray, Icon, shell32.dll, 81 
; This is the WayText Settings code.
; updated 6-3-2022

;==========Read from Settings file======== 
iniread, varHotkey, wtFiles\Settings.ini, MainSettings, MyHotkey
iniread, varStayInRAM, wtFiles\Settings.ini, MainSettings, StayInRAM
iniread, varVisualMode, wtFiles\Settings.ini, MainSettings, VisualSendMode
iniread, varPasteDelay, wtFiles\Settings.ini, MainSettings, PostPasteDelay
iniread, varTypeDelay, wtFiles\Settings.ini, MainSettings, PostTypeDelay
iniread, varFaveEditor, wtFiles\Settings.ini, MainSettings, FaveEditor
iniread, varTargetWins, wtFiles\Settings.ini, MainSettings, PreferredTargetWins
iniread, varForcePref, wtFiles\Settings.ini, MainSettings, ForceUseOfPreferred
iniread, varColor, wtFiles\Settings.ini, MainSettings, GUIColor
iniread, varFontColor, wtFiles\Settings.ini, MainSettings, FontColor
iniread, varWColor, wtFiles\Settings.ini, MainSettings, GUIwarnColor
iniread, varDebug, wtFiles\Settings.ini, MainSettings, Debug
iniread, varLastTab, wtFiles\Settings.ini, MainSettings, LastTab
iniread, varMon, wtFiles\Settings.ini, schedule, Monday
iniread, varTue, wtFiles\Settings.ini, schedule, Tuesday
iniread, varWed, wtFiles\Settings.ini, schedule, Wednesday
iniread, varThu, wtFiles\Settings.ini, schedule, Thursday
iniread, varFri, wtFiles\Settings.ini, schedule, Friday
iniread, varRememberStu, wtFiles\Settings.ini, MainSettings, RememberStudent
iniread, varMemoryMinutes, wtFiles\Settings.ini, MainSettings, MemoryMinutes 
iniread, varMyColors, wtFiles\Settings.ini, ColorsList
;=========================================

WinGetPos, X, Y, W, H, A   	; "A" to get the active window's position.
X := X + (W * 0.05) ; Use these with GUI Show, below.
Y := Y + (H * 0.2)
IF (!Y)  ; If launched and can't get Win position, use screen size/4.
{
	X := A_ScreenWidth / 4
	Y := A_ScreenHeight / 4
}

if (strLen(varColor) > 8) ; There's more than just a hexcode, so do subStrings. 
{
	varColorName := subStr(varColor, 1, strLen(varColor) - 8)
	varColorCode := subStr(varColor, strLen(varColor) - 5, 6)
}
else
{
	varColorName = %varColor%
	varColorCode = %varColor%
}

if (strLen(varFontColor) > 8)
{
	varFontColorName := subStr(varFontColor, 1, strLen(varFontColor) - 8)
	varFontColorCode := subStr(varFontColor, strLen(varFontColor) - 5, 6)
}
else
{
	varFontColorName = %varFontColor%
	varFontColorCode = %varFontColor%
}

Gui, Destroy
Gui, -MinimizeBox +alwaysOnTop
Gui, font, c%varFontColorCode% s11
Gui, color, %varColorCode%
myTabs := "Activation Mode|Send Mode|Editor|Files|Targets|Colors|Schedule|Pre-Fill|Debug"  
Gui Add, Tab3, AltSubmit vCurrTab Choose%varLastTab%, %myTabs% ; AltSubmit so we can save the Tab number and open with same.

;###############################################################################################
Gui Tab, 1 ;######## ACTIVATION MODE #####################################
Gui Add, Text, Wrap  w340, Exit the app from RAM each time?  If used as a "stand alone" application, then staying running in RAM between uses is recommended.  If there is another "master script" which is already running all the time, then having WayText exit each time makes sense. 
ifEqual, varStayInRAM, 1
{
	RAMMode := "checked"
	exitMode := ""
}
else
{
	RAMMode := ""
	exitMode := "checked"
}
gui, add, groupbox, R2 w340, Mode
Gui Add, Radio, yp+18 xp+10 wrap gYesStay %exitMode% , Activated from another script, so exit each use.
Gui Add, Radio, wrap vStayMode gYesStay %RAMMode% , Stay running in RAM and use hotkey to launch.

IfExist %A_Startup%\WayText.lnk
{
	StartCheck = Checked
	StartTxt = Unheck to NOT start with Windows.
}
else
{
	StartCheck = 
	StartTxt = Check to start with Windows.
}

Gui Add, Text, yp+34 Wrap w340 vChosenHotkeyTxt, The current hotkey is indicated below. Change if desired.  
Gui Add, Hotkey, vChosenHotkey, %varHotkey% 
Gui Add, CheckBox, vVarStartup gStartupLbl %StartCheck%, %StartTxt%

ifEqual, varStayInRAM, 1
{
	GuiControl, Enable, ChosenHotkeyTxt
	GuiControl, Enable, ChosenHotkey
	GuiControl, Enable, VarStartup
}
else
{
	GuiControl, Disable, ChosenHotkeyTxt
	GuiControl, Disable, ChosenHotkey
	GuiControl, Disable, VarStartup
}

;###############################################################################################
Gui Tab, 2 ;######### SEND MODE ####################################
Gui Add, Text , Wrap gTipsSendMode w340, Click for Tips about Send Mode.

ifEqual, varVisualMode, 1
{
	ModeVisual := "checked"
	ModeSafer := ""	
}
else
{
	ModeVisual := ""
	ModeSafer := "checked"	
}

;ifEqual, varTypeDelay, 1


gui, add, groupbox, R2 w340, Text Type Send Modes
Gui Add, Radio, yp+20 xp+10 %ModeSafer% , Safer and Faster, but works in Background.
Gui Add, Radio, vVisMode %ModeVisual% , More Visual, but prone to errors.

Gui Add, Text, xp-12 yp+60 Wrap gTipsTypePasteDelay w340, Click for Tips about Delay.
gui, add, groupbox, R3 w340, Post Type / Paste Delay
Gui, Add, Edit, yp+22 xp+10 vDelayEdit w60 cBlack
Gui, Add, UpDown, vPasteDelay Range1-2000, %varPasteDelay%
Gui, Add, Text, yp+3 xp+65, Millisecond post-paste delay. 
Gui, Add, Checkbox, yp+35 xp-60 vTypeDelay checked%varTypeDelay%, Add a dynamic delay to wait for typing. ; make this disabled when visual = 0

;###############################################################################################
Gui Tab, 3 ;####### EDITOR #########################################
Gui Add, text, Wrap w340, The Notice and Tests INI libraries can be opened from the WayText window.  Currently assigned editor for opening INI files is:

If (StrLen(varFaveEditor)>48) ; If the path is too long, it make the GUI too wide. 
	EditorLBL := SubStr(varFaveEditor, 1, 3) "...." SubStr(varFaveEditor, -40)
Else
	EditorLBL = %varFaveEditor%	
	
Gui Add, text,, %EditorLBL%
Gui, add, button,  section gChooseEditor , Choose Different Editor
Gui, add, button,  gScite , Use Embeded SciTE


;###############################################################################################
Gui Tab, 4 ;###### FILES #########################################
Gui Add, Text , Wrap  w340, These are the INI files that WayText pulls boilerplate information from.  They also populate the lists of items that appear in the WayText main form. Click to open.
;Gui, font, bold
Gui, Add, Text, xp+24 yp+80 section gSchoolsLabel, ---> List of Schools
Gui, Add, Text, gNoticesLabel, ---> List of Boilerplate Entries
Gui, Add, Text, gSuffixLabel, ---> List of Test Item 'Suffixes'
Gui, Add, Text, gTestsLabel, ---> Test Bank
;Gui, font, 

;###############################################################################################
Gui Tab, 5 ;####### TARGETS ########################################
Gui Add, Text , Wrap  w340, "Preferred" target windows are those that you intend to send text input to.  It is easy (and frustrating) to accidentally send a bunch of key presses to the wrong window, or to the desktop. Enter a list of preferred windows, separated by comma space. RegEx partial-match rules used to identify windows by their titles. 
varTargetWins := StrReplace(varTargetWins,"|",", ")

Gui Add, Edit, +wrap  w340 h42 vVarTargetWins cBlack, %varTargetWins%
gui, add, text, +wrap  w340, Check below to only type into preferred windows. WayText uses a popup MessageBox if accidentally triggered in wrong window. (Note: Some text edit fields will automatically be "preferred.") Tip: Holding <Shift> forces use of MsgBox regardless of window.
Gui Add, CheckBox, xs+10 vChkForcePref checked%varForcePref%, Use MsgBox if target window is non preferred.

;###############################################################################################
Gui Tab, 6  ;####### COLORS #########################################
Gui Add, Text , Wrap  w340, If WayText is activated in a non-preferred taget window, the "Warning" Color is used as the color of the WayText Form.  Choose a color or paste in a 6-char Hex Code. ListBoxes and EditBoxes will always be Windows default colors. 

varMyColors := StrReplace(varMyColors,"`n","|") ; Must|convert|to|this.

loop, parse, varMyColors, "|"
	if (A_loopfield = varColor)
		ColorChoose := A_Index ; Get position of current color for 'Choose' option.
Gui Add, ComboBox, w160 vvarColor gColorChange Section Choose%ColorChoose%, %varMyColors%

loop, parse, varMyColors, "|"
	if (A_loopfield = varFontColor)
		FontColorChoose := A_Index
Gui Add, ComboBox, w160 vvarFontColor gFColorChange Choose%FontColorChoose%, %varMyColors%

loop, parse, varMyColors, "|"
	if (A_loopfield = varWColor)
		WColorChoose := A_Index
Gui Add, ComboBox,  w160 vvarWColor gWColorChange Choose%WColorChoose%, %varMyColors%

if (strLen(varWColor) > 8)
{
	varWColorName := subStr(varWColor, 1, strLen(varWColor) - 8)
	varWColorCode := subStr(varWColor, strLen(varWColor) - 5, 6)
}
else
{
	varWColorName = %varWColor%
	varWColorCode = %varWColor%
}

Gui Add, text, ys vTxtForm Section, Form: %varColorName%
Gui Add, text, vTxtFont Section, Font: %varFontColorName%
Gui Add, text, vTxtWarning, Warning: %varWColorName%

Gui, Add, Progress, xp-174  yp+30 w330 h50 c%varWColorCode%, 100
Gui Add, text, xp+14 yp+7 +BackgroundTrans, Sample of color when activated from a`nnon-preferred window: [ %varWColorName% ] .
Gui Add, text, xp+45 yp+56 gColorPicker, -->   [ Launch Color Picker ]   <--
;###############################################################################################
Gui Tab, 7 ;###### SCHEDULE #########################################
Gui Add, Text , Wrap  w340, In Notices Tab, choose which school should be the default item for each day of the week. 
Gui Add, Text, section, Monday
Gui Add, Text, , Tuesday
Gui Add, Text, , Wednesday
Gui Add, Text, , Thursday
Gui Add, Text, , Friday

IniRead, AllSchools, wtFiles\SchoolList.ini ; Gets `n-delimited list from ini file.
AllSchools := StrReplace(AllSchools,"`n","|") ; Format|list|like|this.
Gui Add, DropDownList, ys section w130 AltSubmit vvarMonBld Choose%varMon%, %AllSchools%
Gui Add, DropDownList, w130 vvarTueBld AltSubmit Choose%varTue%, %AllSchools%
Gui Add, DropDownList, w130 vvarWedBld AltSubmit Choose%varWed%, %AllSchools%
Gui Add, DropDownList, w130 vvarThuBld AltSubmit Choose%varThu%, %AllSchools%
Gui Add, DropDownList, w130 vvarFriBld AltSubmit Choose%varFri%, %AllSchools%

;###############################################################################################
Gui Tab, 8 ;###### PREFILL #########################################
Gui Add, Text , Wrap  w340, Should WayText remember the Name, Gender, and School that was used with the last text replacement? NOTE:  This memory will override the school chosen in the Schedule tab. 

ifEqual, varRememberStu, 1
	MemoryMode := "checked"
else
	MemoryMode := ""
Gui Add, Checkbox, vUseMemory gMemoryToggle %MemoryMode%, Remember the last used student information.

Gui Add, Text, Wrap w340 vMemoryDurationTxt, Last used information should be prefilled if the last use was within this many mintes. Choose from 1-600. If WayText has been unused for more minutes than this, the default name, gender, school values will be used. 
Gui, Add, Edit, vMemoryEdit w60 cBlack
Gui, Add, UpDown, vMemoryMinutes Range1-600, %varMemoryMinutes%

ifEqual, varRememberStu, 1
{
	GuiControl, Enable, MemoryDurationTxt
	GuiControl, Enable, MemoryEdit
	GuiControl, Enable, MemoryMinutes
}
else
{
	GuiControl, Disable, MemoryDurationTxt
	GuiControl, Disable, MemoryEdit
	GuiControl, Disable, MemoryMinutes
}

;###############################################################################################
Gui Tab, 9 ;###### DEBUG #########################################
Gui Add, Text , Wrap  w340, If Debug mode is checked, several Popup Messages will occur, showing what the text looks like on its stages from INI file to being typed or pasted.`n`nIf there are many "Optional" GUIs in a text entry, or many items in the Optional GUIs, then there may be several dozen Popup Messages.

ifEqual, varDebug, 1
	DebugMode := "checked"
else
	DebugMode := ""
Gui Add, Checkbox, vUseDebug %DebugMode%, Show Debug information during execution.

;###############################################################################################
Gui Tab ;###### END OF TABS #########################################

Gui Add, Button, w106 h30 Section, Apply
Gui Add, Button, ys w136 h30 gApply_Then_Close, Apply Then Close
Gui Add, Button, ys w106 h30, Cancel
Gui Show, x%X% y%Y%, WayText Settings

if (varHotkey = "ERROR")  ; Will catch if Settings INI is missing.
  MsgBox, 262192, Error Reading File, There may be one or more missing INI files that are needed.  In the same folder as this AHK file, there should be a folder called "wtFiles."  Inside of wtFiles should be the following files: `n`n`tNoticeDefinitions.ini`n`tSchoolList.ini`n`tSettings.ini`n`tTestBank.ini`n`tTestSuffixes.ini
Return

TipsSendMode:
MsgBox, 262192, Send Modes Tips, How should the replacement text get typed into the target window? In Google Chrome text boxes, "safe mode" will cause WayText to run in the background.  The text won't be seen until the script is completely finished.  Then Chrome will 'refresh' the page.  During this time, extraneous mouse clicks and key presses are mostly ignored.  That's why it's "safe mode." `n**Note that, if an INI key name contains "Paste," then the send mode is largely irrelevant for that key. 
Return

TipsTypePasteDelay:
MsgBox, 262192, Paste / Type Delay Tips, It takes 100 miliseconds or so for Windows to clear and rewrite its build in clipboard.  This mostly matters if a text entry has multiple "Paste Keys" back-to-back. The digit setting causes a pause (in miliseconds) after each paste command. `n`nThe checkbox is for a dynamically-changing post-typing delay.  This is only applied if an Entry conains paste keys AND type keys.  Checked is recommended, however this is only relevant if Send Mode is set to "Safer/Faster."  Note: It is dynamic, because the length of delay is based on the length of the text string that is to be typed out.  This is not a perfect system because WayText will type into different apps at different speeds.  
Return

ColorChange:
	gui, submit, nohide
	varColorName := subStr(varColor, 1, strLen(varColor) - 8)
	guicontrol,,TxtForm, Form: %varColorName%	
	varColorCode := subStr(varColor, strLen(varColor) - 5, 6)
	gui, color, %varColorCode%
return

FColorChange:
	gui, submit, nohide	
	varFontColorName := subStr(varFontColor, 1, strLen(varFontColor) - 8)
	varFontColorCode := subStr(varFontColor, strLen(varFontColor) - 5, 6)	
	Gui, Font, s11 c%varFontColorCode%
	WinGet, list, ControlList
	For each, control in StrSplit(list, "`n")
		GuiControl, Font, %control%
	GuiControl, MoveDraw, %control%
	guicontrol,,TxtFont , Font: %varFontColorName%
return

WColorChange:
	gui, submit, nohide
	varWColorName := subStr(varWColor, 1, strLen(varWColor) - 8)
	guicontrol,,TxtWarning, Warning: %varWColorName%
	varWColorCode := subStr(varWColor, strLen(varWColor) - 5, 6)
	gui, color, %varWColorCode%
return

YesStay: ; If stay in RAM, enable hotkey cmd. 
	Gui, Submit, NoHide
	If (StayMode = 1)
	{
		GuiControl, Disable, ChosenHotkeyTxt
		GuiControl, Disable, ChosenHotkey
		GuiControl, Disable, VarStartup
		StayMode -= 1  ; Radio buttons return 1 or 2 so, change those into 0 or 1 for our ini file.
		IniWrite, %StayMode%, wtFiles\Settings.ini, MainSettings, StayInRAM
		IniWrite, %ChosenHotkey%, wtFiles\Settings.ini, MainSettings, MyHotkey
		IfExist %A_Startup%\WayText.lnk
		{
			FileDelete %A_Startup%\WayText.lnk
			StartCheck = 
			MsgBox, 0x1000, WayText Settings, WayText will NO LONGER auto start with Windows.
			reload
		}	

	}
	Else If (StayMode = 2)
	{
		GuiControl, Enable, ChosenHotkeyTxt
		GuiControl, Enable, ChosenHotkey
		GuiControl, Enable, VarStartup
	}	
Return

StartupLbl:
	Gui, Submit, NoHide 
	If (VarStartup = 1)
	{
		FileCreateShortcut %A_WorkingDir%\WayText.exe,%A_Startup%\WayText.lnk
		MsgBox, 0x1000, WayText Settings, WayText will auto start with Windows.
	}
	Else If (VarStartup = 0)
	{
		FileDelete %A_Startup%\WayText.lnk
		MsgBox, 0x1000, WayText Settings, WayText will NO LONGER auto start with Windows.
	}
Return

MemoryToggle:
	Gui, Submit, NoHide 
	ifEqual, useMemory, 1
	{
		GuiControl, Enable, MemoryDurationTxt
		GuiControl, Enable, MemoryEdit
		GuiControl, Enable, MemoryMinutes
	}
	else
	{
		GuiControl, Disable, MemoryDurationTxt
		GuiControl, Disable, MemoryEdit
		GuiControl, Disable, MemoryMinutes
	}
Return

ButtonApply:
Apply_Then_Close: 
	gui, submit, NoHide
	iniWrite, %CurrTab%, wtFiles\Settings.ini, MainSettings, LastTab ; Number for open tab, so we can restore it.
		;======= Tab 1 Stay in RAM mode ===================
	StayMode -= 1  ; Radio buttons return 1 or 2 so, change those into 0 or 1 for our ini file.
	IniWrite, %StayMode%, wtFiles\Settings.ini, MainSettings, StayInRAM
	IniWrite, %ChosenHotkey%, wtFiles\Settings.ini, MainSettings, MyHotkey
		;======= Tab 2 Send text mode =====================
	VisMode -= 1
	IniWrite, %VisMode%, wtFiles\Settings.ini, MainSettings, VisualSendMode
	IniWrite, %PasteDelay%, wtFiles\Settings.ini, MainSettings, PostPasteDelay
	IniWrite, %TypeDelay%, wtFiles\Settings.ini, MainSettings, PostTypeDelay	
		;========  Tab 3 Fave Editor ======================
		;======== Tab 4 Fave Windows ======================
	varTargetWins := StrReplace(varTargetWins,", ","|")
	IniWrite, %varTargetWins%, wtFiles\Settings.ini, MainSettings, PreferredTargetWins
	IniWrite, %ChkForcePref%, wtFiles\Settings.ini, MainSettings, ForceUseOfPreferred
		;======= Tab 5 Colors =============================
	varColor := StrReplace(varColor, "#", "")
	iniWrite, %varColor%, wtFiles\Settings.ini, MainSettings, GUIColor
	varFontColor := StrReplace(varFontColor, "#", "")
	iniWrite, %varFontColor%, wtFiles\Settings.ini, MainSettings, FontColor
	varWColor := StrReplace(varWColor, "#", "")
	iniWrite, %varWColor%, wtFiles\Settings.ini, MainSettings, GUIwarnColor
		;======= Tab 6 Schedule ===========================
	iniWrite, %varMonBld%, wtFiles\Settings.ini, schedule, Monday
	iniWrite, %varTueBld%, wtFiles\Settings.ini, schedule, Tuesday
	iniWrite, %varWedBld%, wtFiles\Settings.ini, schedule, Wednesday
	iniWrite, %varThuBld%, wtFiles\Settings.ini, schedule, Thursday
	iniWrite, %varFriBld%, wtFiles\Settings.ini, schedule, Friday
		;======= Tab 7 Prefill ===========================
	iniWrite, %UseMemory%, wtFiles\Settings.ini, MainSettings, RememberStudent
	iniWrite, %MemoryMinutes%, wtFiles\Settings.ini, MainSettings, MemoryMinutes 
		;======= Tab 9 Debug =============================
	iniWrite, %UseDebug%, wtFiles\Settings.ini, MainSettings, Debug 
	
	Sleep, 200
	run, WayText.exe ; Restart WayText so that it will read the changed wtSettings file.
	
if (A_ThisLabel = "Apply_Then_Close")
	ExitApp
else
{
	Reload
	Return
}

	;======= Tab 8 Files ===========================
SchoolsLabel:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\SchoolList.ini",, UseErrorLevel 
	If ErrorLevel 
		run, wtFiles\SchoolList.ini ; If Scite is not found, will be prompted to choose default ini opener.
return
NoticesLabel:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\NoticeDefinitions.ini",, UseErrorLevel
	If ErrorLevel 
		Run, wtFiles\NoticeDefinitions.ini
return
SuffixLabel:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\TestSuffixes.ini",, UseErrorLevel
	If ErrorLevel 
		run, wtFiles\TestSuffixes.ini
return
TestsLabel:
	run, %varFaveEditor% "%A_ScriptDir%\wtFiles\TestBank.ini",, UseErrorLevel
	If ErrorLevel 
		run, wtFiles\TestBank.ini
return

ChooseEditor:
	;FileSelectFile, OutputVar , Options, RootDir\Filename, Title, Filter
	FileSelectFile, SelectedEditor, 3, , Choose favorite editor, Application (*.exe)
	if (SelectedEditor = "")
		MsgBox, 0x1000, WayText Settings, No app was selected.
	else
		IniWrite, %SelectedEditor%, wtFiles\Settings.ini, MainSettings, FaveEditor
	;run, WayText.exe ; Restart WayText.
ExitApp

Scite:
	if FileExist("SciTE\SciTE.exe") 
		IniWrite, %A_ScriptDir%\SciTE\SciTE.exe, wtFiles\Settings.ini, MainSettings, FaveEditor
	else
		MsgBox, 0x1000, WayText Settings, Scintilla Text Editor (SciTE) not found bundled with WayText.
Reload

ButtonCancel:
GuiEscape:
GuiClose:
ExitApp

ColorPicker:
Loop, ;based on WhatColor.ahk, by Skrommel @2005
{
  MouseGetPos,cpx,cpy
  PixelGetColor,rgb,cpx,cpy,RGB
  StringTrimLeft,rgb,rgb,2
  ToolTip,Point at desired color.`nThen press [Shift] to`ncopy the 6-character`ncode to the clipboard.`n`n         --> %rgb% <--`n`n
  if GetKeyState("Shift","P")
  {
    Clipboard=%rgb%
	ToolTip, Hexcode captured`nto Clipboard`n`n   *** %rgb% ***
    Sleep, 2000
	send {Shift up}
	ToolTip,
	Break	
  }
  Sleep,10
}